//ICC-AVR application builder : 22.04.2010 13:46:06
// Target : M8
// Crystal: 8.0000Mhz

#include <iom8v.h>
#include <macros.h>

unsigned char count;

void port_init(void)
{
 PORTB = 0xFB;
 DDRB  = 0x2E;
 PORTC = 0x7F; //m103 output only
 DDRC  = 0x00;
 PORTD = 0xFB;
 DDRD  = 0x36;
}


#pragma interrupt_handler int1_isr:3
void int1_isr(void)
{
 //external interupt on INT1
}

//TIMER1 initialize - prescale:1
// WGM: 10) PWM phz correct, TOP= ICRn
// desired value: 15.686KHz
// actual value: 15,686KHz (0,0%)
void timer1_init(void)
{
 TCCR1B = 0x00; //stop
 TCNT1H = 0x00; //setup
 TCNT1L = 0x01;
 OCR1AH = 0x00;
 OCR1AL = 0xFF;
 OCR1BH = 0x00;
 OCR1BL = 0xFF;
 ICR1H  = 0x00;
 ICR1L  = 0xFF;
 TCCR1A = 0x32;
 TCCR1B = 0x11; //start Timer
}


#pragma interrupt_handler timer1_ovf_isr:9
void timer1_ovf_isr(void)
{
 //TIMER1 has overflowed
// TCNT1H = 0x00; //reload counter high value
// TCNT1L = 0x01; //reload counter low value
 
// OCR1BH = 0x00;
// OCR1BL = count;
 OCR1BL = ADCL;
 ADCSR |= 1 << ADIF;
 count+=13;
 
 ADCSR |= 1 << ADSC;
 
}


//ADC initialize
// Conversion time: 52uS
void adc_init(void)
{
 ADCSR = 0x00; //disable adc
 ADMUX = 0x00; //select adc input 0
 ACSR  = 0x80;
 ADCSR = 0x85;//8D
}


//call this routine to initialize all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 port_init();
 timer1_init();
 adc_init();

 MCUCR = 0x08;
 GICR  = 0x80;
 TIMSK = 0x04; //timer interrupt sources
 SEI(); //re-enable interrupts
 //all peripherals are now initialized
}





void main(void)
{
 count = 0;
 init_devices();
 
 do
 {
 }while(1);
}